<template>
  <q-page class="detail--padding bg-grey-1" role="region" aria-label="Detail">
    <q-card class="shadow-1" role="grid">
      <q-card-section class="concept__heading text-weight-bold">
        <div class="text-primary" role="heading" aria-level="3"><span v-if="concept">{{ concept.name }}</span></div>
      </q-card-section>
      <div v-if="concept">
        <div class="row" role="row">
          <div class="col-3 label" role="rowheader">ID</div>
          <div class="col-8 value bg-blue-grey-1" role="cell">{{ concept.id }}</div>
        </div>
        <div class="row" role="row">
          <div class="col-3 label" role="rowheader">Name</div>
          <div class="col-8 value bg-blue-grey-1" role="cell">{{ concept.name }}</div>
        </div>
        <div class="row" role="row">
          <div class="col-3 label" role="rowheader">Balance</div>
          <div class="col-8 value bg-blue-grey-1" role="cell">{{ concept.balance }}</div>
        </div>
        <div class="row" role="row" v-if="concept.itemtype && concept.itemtype.enumeration">
          <div class="col-3 label" role="rowheader">Enumeratie</div>
          <div class="col-8 value bg-blue-grey-1" role="cell">
            <q-expansion-item dense :caption="concept.itemtype.name">
              <q-item dense v-for="(opt, ind) in get_options(concept.itemtype.enumeration)" :key="ind">
                {{ opt }}
              </q-item>
            </q-expansion-item>
          </div>
        </div>
        <div class="row" role="row">
          <div class="col-3 label" role="rowheader">Namespace prefix</div>
          <div class="col-2 value bg-blue-grey-1">{{ concept.ns_prefix }}</div>
        </div>
        <div class="row" role="row">
          <div class="col-3 label" role="rowheader">Namespace</div>
          <div class="col-8 value bg-blue-grey-1" role="cell">{{ concept.namespace }}</div>
        </div>

        <div class="row" role="row">
          <div class="col-3 label" role="rowheader">Period type</div>
          <div class="col-8 value bg-blue-grey-1" role="cell">{{ concept.periodtype }}</div>
        </div>
        <div class="row" role="row">
          <div class="col-3 label" role="rowheader">Substitution group</div>
          <div class="col-8 value bg-blue-grey-1" role="cell">{{ concept.substitution_group }}</div>
        </div>
        <div class="row" role="row">
          <div class="col-3 label" role="rowheader">Abstract</div>
          <div class="col-8 value bg-blue-grey-1" role="cell">{{ concept.abstract }}</div>
        </div>
        <div class="row" role="row" v-if="!concept.abstract">
          <div class="col-3 label" role="rowheader">Nillable</div>
          <div class="col-8 value bg-blue-grey-1" role="cell">{{ concept.nillable }}</div>
        </div>
        <div class="row" role="region" aria-label="Labels">
          <div class="col-3 label" role="heading" aria-level="3">Labels</div>
          <div class="col-8 labels">
            <table>
              <thead>
              <tr>
                <th v-for="col in labelColumns" v-bind:key="col" role="columnheader">
                  {{ col }}
                </th>
              </tr>
              </thead>
              <tbody>
              <tr v-for="(label, index) in concept.labels" v-bind:key="index">
                <td class="bg-blue-grey-1 value">{{ label.label_text }}</td>
                <td>{{ label.lang }}</td>
                <td>{{ label_nice_role(label) }}</td>
              </tr>
              </tbody>
            </table>
          </div>
        </div>
        <!-- Referenties -->
        <div class="row" v-if="concept.references && concept.references.length" role="region" aria-label="Referenties">
          <div class="col-3 label" role="heading" aria-level="3">Referenties</div>
          <div class="col-8 referenties">
            <table>
              <thead>
              <tr>
                <th>Naam</th>
                <th>Vindplaats</th>
              </tr>
              </thead>
              <tbody>
              <tr v-for="reference in concept.references" :key="reference.id">
                <td>{{ reference.name }}</td>
                <td>{{ showReference(reference) }}</td>
              </tr>
              </tbody>
            </table>
          </div>
        </div>
        <!-- itemtype -->
        <div class="row" role="region" aria-label="Itemtype" v-if="concept.itemtype">
          <div class="col-3 label" role="heading" aria-level="3">Itemtype</div>
          <div class="col-8 itemtype">
            <ItemTypeQuickview :itemtype="concept.itemtype"></ItemTypeQuickview>
          </div>
        </div>
      </div>
    </q-card>
    <q-card class="q-mt-lg shadow-1" role="region" aria-label="Gebruik">
      <q-card-section class="gebruik__heading text-primary text-weight-bold" role="heading" aria-level="2">
        Gebruik
      </q-card-section>
      <q-card-section>
        <ConceptBackreference :dts_name="dts_name" :concept_id="concept_id"
                              :nt_version="nt_version"></ConceptBackreference>
      </q-card-section>
    </q-card>
  </q-page>
</template>

<script>
import {api} from 'boot/axios'
import SharedMethods from "components/SharedMethods";
import ItemTypeQuickview from "components/ItemTypeQuickview";
import ConceptBackreference from "components/./ConceptBackreference"

export default {
  name: "ConceptDetail",
  components: {ConceptBackreference, ItemTypeQuickview},
  data() {
    return {
      concept: undefined,
      loading: true,
    }
  },
  created() {
    if (this.concept_id) {
      this.fetchData(this.concept_id)
    }
    this.label_nice_role = SharedMethods.label_nice_role
    this.get_label = SharedMethods.get_label
  },

  computed: {
    labelColumns() {
      return ["Label of tekst", "Taal", "Rol"]
    }
  },
  props: {
    concept_id: String,
    dts_name: String,
    nt_version: String,
  },
  watch: {
    concept_id: function () {
      this.loading = true
      this.fetchData()
    }
  },
  methods: {
    fetchData: function () {
      if (this.concept_id) {
        api
          .get("/dts/" + this.dts_name + "/concepts/" + this.concept_id,
            {params: {nt_version: this.nt_version, full: 1}})
          .then(response => {
            this.concept = response.data
          })
      }
      this.loading = false
    },
    showReference: function (reference) {
      /*
       * extracts the relevant parts of the reference, excluding name,id and label
       */
      let result = ''
      Object.keys(reference).forEach(function (key) {
        if (['name', 'label', 'id'].indexOf(key) === -1) {
          if (reference[key]) {
            result += key + ': ' + reference[key] + ' ';
          }
        }
      })
      return result
    },
    get_options: function (enumeration) {
      let options = []
      let that = this
      enumeration.forEach(function (option) {
        let option_text = that.get_label(option)
        if (option_text !== option.value) {
          option_text = option_text + " (" + option.value + ")"
        }
        options.push(option_text)
      })
      return options
    }
  }
}
</script>

<style scoped lang="scss">
.concept__heading {
  border-left: 10px solid $primary;
  border-bottom: 1px solid $primary;
  font-size: 20px;
  margin-bottom: 10px;
}

.gebruik__heading {
  border-left: 10px solid $primary;
  border-bottom: 1px solid $primary;
  font-size: 18px;
  margin-bottom: 10px;
}

.value {
  border-radius: 5px;
  padding: 5px 0 5px 10px;
}

.detail--padding {
  padding: 30px;
}

.row {
  padding: 5px 0 0 0;
}

.label {
  padding: 5px 0 5px 10px;
}

table {
  border-spacing: 5px;
  width: 100%;
}

th {
  text-align: left;
}

td {
  vertical-align: top;
}
</style>
